#!/bin/bash
set -e
BASE_DIR="$(cd -P "$(dirname "${BASH_SOURCE[0]}")" && pwd -P)"
cd "${BASE_DIR}"

./trainDataStocks.sh

cd "${BASE_DIR}/.."
rm -rf .trace
mkdir .trace

function copyNetworks(){

  mkdir -p .creatures
  touch ".run.pid"

  find ../GRQ-sampler/samples/ -name "*.json" -mmin -120 -exec cp {} .creatures/ \;

  if [[ -s "../GRQ-cluster/network.json" ]]; then
    cp "../GRQ-cluster/network.json" .creatures/cluster.json
  fi

  if [[ -s ".network.json" ]]; then
    cp ".network.json" .creatures/network.json
  fi

  if [[ -s ".network-sampler.json" ]]; then
    cp ".network-sampler.json" .creatures/sampler.json
  fi

  if [[ -s "../GRQ-portfolio/best/network.json" ]]; then
    cp "../GRQ-portfolio/best/network.json" .creatures/best.json
  fi
}

copyNetworks

HOST=$(hostname)
HOST=${HOST%.local}
export RUST_BACKTRACE=1
find .creatures -name '[1-9][0-9].json' -exec rm {} \;
set +e
deno run \
  --v8-flags=--max-old-space-size=8192 \
  --allow-read --allow-write --allow-net \
  src/Learn.ts \
    --timeout=45 \
    --populationSize=20 \
    --elitism=3 \
    --log=1 \
    --trainingSampleRate=0.001 \
    --verbose=true

deno run \
  --v8-flags=--max-old-space-size=8192 \
  --allow-read --allow-write --allow-net \
   https://deno.land/x/tags@v1.0.2/App.ts \
    --directory=.creatures \
    --tagList="LEARN=${HOST}"

# Only if we successfully change the worker date ( so that we don't lose a regression)
cp .fetch.txt .tmp/success/fetch.txt
